<script setup lang="ts">
import { onMounted, ref } from 'vue'

// import DialogEdit from '../Member/DialogEdit.vue'

import { useMembersStore } from '@/stores/member'
import { useReceiptStore } from '@/stores/receipt'
import { useAuthStore } from '@/stores/auth'

import type { Member } from '@/types/Member'
import type { VForm } from 'vuetify/components'
// import HelloWorld from '@/components/HelloWorld.vue'

const tel = ref('')
const point1 = ref()
const memberStore = useMembersStore()
const receiptStore = useReceiptStore()
const point = ref(0)
const dialogMember = ref(false)
const refform = ref<VForm | null>(null)
const form = ref(false)
const validation = ref(true)
const p = ref<number>(0)
const authStore = useAuthStore()

async function onClick() {
  await memberStore.searchMember(tel.value)
  receiptStore.calReceipt()
  setTel()
  askDiscountMember()
}

async function onClickMem(tel: string) {
  await memberStore.searchMember(tel)
  receiptStore.calReceipt()
  setTel()
  askDiscountMember()
}
async function usePoint() {
  let { valid } = await refform.value!.validate()
  validation.value = valid
  if (!valid) return
  receiptStore.setDisMember(point1.value)
  memberStore.usePoint(point1.value)
  dialogMember.value = false
  point1.value = ''
}
function askDiscountMember() {
  receiptStore.setDisMember(0)
  console.log(memberStore.currentMember)

  if (memberStore.currentMember != null && memberStore.currentMember != undefined) {
    point.value = memberStore.currentMember.point
    if (point.value >= 10) {
      dialogMember.value = true
    }
  }
}
const setTel = () => {
  tel.value = ''
}
function OnInput() {
  tel.value = tel.value.replace(/[^0-9]/g, '')
  memberStore.editedMember.tel = memberStore.editedMember.tel.replace(/[^0-9]/g, '')
  point1.value = point1.value.replace(/[^0-9]/g, '')
}

function usePointValidate() {
  if (!point1.value) {
    return 'โปรดใส่จำนวนเงินที่ลด'
  }
  const maxDiscount = Math.floor(point.value / 10)
  const enteredValue = parseInt(point1.value, 10)

  if (enteredValue > maxDiscount) {
    validation.value = false
    return `จำนวน point เกินขีดจำกัด (${maxDiscount} บาท)`
  }
  validation.value = true
  return true
}

function checkNumber(e: any) {
  const charCode = e.keyCode
  if (charCode < 48 || charCode > 57) {
    e.preventDefault()
  }
}

function btnNotShow() {
  if (receiptStore.receiptItems.length < 1) {
    return true
  } else {
    return false
  }
}


</script>

<template>
  <v-container>
    <v-row align="center">
      <v-col cols="12" md="4">
        <v-text-field
          v-if="receiptStore.isEmp()"
          v-model="tel"
          density="compact"
          variant="solo"
          label="Search Member"
          append-inner-icon="mdi-magnify"
          hide-details
          @click:append-inner="onClick()"
          @keyup.enter="onClick()"
          inputmode="numeric"
          pattern="[0-9]*"
          clearable
          :maxlength="10"
          @keypress="checkNumber"
          :disabled="btnNotShow()"
        >
        </v-text-field>
        <v-btn
          v-else
          block
          prepend-icon="mdi-star-four-points-circle-outline"
          color="brown"
          @click="onClickMem(authStore.getCurrentMember()?.tel!)"
          :disabled="btnNotShow()"
          >Use Point</v-btn
        >
      </v-col>
      <v-col cols="12" md="5" class="pa-2">
        <div v-if="receiptStore.isEmp()">
          Member: {{ memberStore.currentMember ? memberStore.currentMember?.name : '-' }}
        </div>
        <div v-else>
          Member: {{ authStore.getCurrentMember() ? authStore.getCurrentMember()?.name : '-' }}
        </div>
      </v-col>
      <v-divider :thickness="2" class="border-opacity-100" vertical></v-divider>
      <v-col cols="12" md="2" class="pa-2">
        <div v-if="receiptStore.isEmp()">
          Point: {{ memberStore.currentMember ? memberStore.currentMember?.point - p : '-' }}
        </div>
        <div v-else>
          Point:
          {{
            memberStore.currentMember
              ? memberStore.currentMember?.point - p
              : authStore.getCurrentMember()?.point
          }}
        </div>
      </v-col>
    </v-row>
  </v-container>
  <!--dialog ask Point member-->
  <v-dialog v-model="dialogMember" persistent width="auto">
    <v-card>
      <v-card-title class="text-h5"> แต้มสมาชิก </v-card-title>
      <v-card-text
        >คุณลูกค้ามี point ทั้งหมด {{ point }} point สามารถแลกได้มากสุด
        <v-form ref="refform" v-model="form" @submit.prevent>
          {{ Math.floor(point / 10) }} บาท
          <v-text-field
            v-model="point1"
            density="compact"
            variant="solo"
            label="Point Member"
            :rules="[usePointValidate]"
            @click:append-inner="usePoint()"
            inputmode="numeric"
            pattern="[0-9]*"
            @input="OnInput"
            hint="10 point แลก 1 บาท"
            persistent-hint
            @keypress.enter.prevent
          >
          </v-text-field>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="green-darken-1" variant="text" @click="dialogMember = false">
          ไม่ใช้แต้ม
        </v-btn>
        <v-btn color="green-darken-1" variant="text" @click="usePoint()" :disabled="!validation">
          ใช้แต้ม
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <DialogEdit></DialogEdit>
</template>
